/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	kumoriv1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeKukuComponents implements KukuComponentInterface
type FakeKukuComponents struct {
	Fake *FakeKumoriV1
	ns   string
}

var kukucomponentsResource = schema.GroupVersionResource{Group: "kumori.systems", Version: "v1", Resource: "kukucomponents"}

var kukucomponentsKind = schema.GroupVersionKind{Group: "kumori.systems", Version: "v1", Kind: "KukuComponent"}

// Get takes name of the kukuComponent, and returns the corresponding kukuComponent object, and an error if there is any.
func (c *FakeKukuComponents) Get(name string, options v1.GetOptions) (result *kumoriv1.KukuComponent, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(kukucomponentsResource, c.ns, name), &kumoriv1.KukuComponent{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuComponent), err
}

// List takes label and field selectors, and returns the list of KukuComponents that match those selectors.
func (c *FakeKukuComponents) List(opts v1.ListOptions) (result *kumoriv1.KukuComponentList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(kukucomponentsResource, kukucomponentsKind, c.ns, opts), &kumoriv1.KukuComponentList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &kumoriv1.KukuComponentList{ListMeta: obj.(*kumoriv1.KukuComponentList).ListMeta}
	for _, item := range obj.(*kumoriv1.KukuComponentList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested kukuComponents.
func (c *FakeKukuComponents) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(kukucomponentsResource, c.ns, opts))

}

// Create takes the representation of a kukuComponent and creates it.  Returns the server's representation of the kukuComponent, and an error, if there is any.
func (c *FakeKukuComponents) Create(kukuComponent *kumoriv1.KukuComponent) (result *kumoriv1.KukuComponent, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(kukucomponentsResource, c.ns, kukuComponent), &kumoriv1.KukuComponent{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuComponent), err
}

// Update takes the representation of a kukuComponent and updates it. Returns the server's representation of the kukuComponent, and an error, if there is any.
func (c *FakeKukuComponents) Update(kukuComponent *kumoriv1.KukuComponent) (result *kumoriv1.KukuComponent, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(kukucomponentsResource, c.ns, kukuComponent), &kumoriv1.KukuComponent{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuComponent), err
}

// Delete takes name of the kukuComponent and deletes it. Returns an error if one occurs.
func (c *FakeKukuComponents) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(kukucomponentsResource, c.ns, name), &kumoriv1.KukuComponent{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeKukuComponents) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(kukucomponentsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &kumoriv1.KukuComponentList{})
	return err
}

// Patch applies the patch and returns the patched kukuComponent.
func (c *FakeKukuComponents) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *kumoriv1.KukuComponent, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(kukucomponentsResource, c.ns, name, pt, data, subresources...), &kumoriv1.KukuComponent{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuComponent), err
}
